local utf8 = require("utf8")
 
function love.load()
	width, height = love.graphics.getDimensions()
	units = 32
	font = love.graphics.newImageFont( 'font.png', ' abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' )
    text = ""
	t_limit = 84
	input = ''
	input1 = ''
	input2 = ''
	State = ''
	p_count = 1
	r = 0
	g = 0
	b = 1 
end

function trim(s)
	return (s:gsub("^%s*(.-)%s*$", "%1"))
end

function punc(s)
	return s:gsub("^%l", string.upper)
end

function split(s)
    result = {}
    for match in s:gmatch("%a+") do
        table.insert(result, match)
    end
    return result
end
 
function love.textinput(t)
	if string.len(text) < t_limit and state == "input" then
		text = text .. t
	end
end
 
function love.keypressed(key)
    if (key == "backspace") then
	    love.keyboard.setKeyRepeat(true)
        local byteoffset = utf8.offset(text, -1)
 
        if byteoffset then
            text = string.sub(text, 1, byteoffset - 1)
        end
    else
	    love.keyboard.setKeyRepeat(false)
	end
	if (key == "return") then
		if state == "input" then
			local splice = split(text)
			input1,input2 = splice[1],splice[2]
			input = trim(punc(tostring(input1)))..' '..trim(punc(tostring(input2)))
			text = ''
		end
		if state == "next" then
			p_count = p_count + 1
		end

	end
end

function love.update(dt)
	
end

function love.draw()

	for i = 0, width/(units/2) do
		for j = 0, height/(units/2) do
			--[[if state == "input" then
			r = math.random(0,1)
			g = math.random(0,1)
			b = math.random(0,1)
			else
			r = 0
			g = 0
			b = 1
			end]]
			love.graphics.setColor(r,g,b,1)
			love.graphics.rectangle("fill",i*units/2,j*units/2,units/2,units/2)
		end
	end
		love.graphics.setFont( font )
	if state == "input" then 
		love.graphics.setColor(1,0,0,1)
		love.graphics.rectangle('fill',16,height-32,width-32,16)
		love.graphics.setColor(1,1,1,1)
		love.graphics.print(text,20,height-32)
	else
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle('fill',16,height-32,width-32,16)
		love.graphics.setColor(1,1,1,1)
	end
	if p_count == 1 then
		if input == '' or input == 'Nil Nil' or input == trim(punc(tostring(input1))).." ".."Nil" then
			state = "input"
			love.graphics.setColor(0,0,0,1)
			love.graphics.rectangle('fill',32,32,32*23,32*16)
			love.graphics.setColor(1,1,1,1)
			love.graphics.print("What are your names?",32,32)
			love.graphics.print("Type in both names and press enter",32,48)
		else
			state = "next"
			love.graphics.setColor(0,0,0,1)
			love.graphics.rectangle('fill',32,32,32*23,32*16)
			love.graphics.setColor(1,1,1,1)
			love.graphics.print("Hello "..input,32,32)
			love.graphics.print("Press enter to go next",16,height-32)
		end
	elseif p_count == 2 then
		state = "next"
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle('fill',32,32,32*23,32*16)
		love.graphics.setColor(1,1,1,1)
		love.graphics.print("This is the end of the program",32,32)
		love.graphics.print("Press enter to restart",16,height-32)
	elseif p_count == 3 then
		input = ''
		p_count = 1
	end
	--[[for i = 0, width/units do
		for j = 0, height/units do
			love.graphics.rectangle('line',i*units,j*units,units,units)
		end
	end]]
	--love.graphics.setColor(1,1,1,1)
	--love.graphics.print(tostring(trim(input)),0,0)
end